



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CSS3 的calc()方法的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CSS3 的calc()方法的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 19:32:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>calc()简单介绍</h3>
<p>calc()对大家来说，或许很陌生，不太会相信calc()是css中的部分。因为看其外表像个函数，既然是函数为何又出现在CSS中呢？这一点也让我百思不得其解，今天有一同事告诉我，说CSS3中有一个属性能实现自适应的布局，首先让我想到的是box-sizing，但跟我说还可以计算，这让我不得不想起calc()。因为早先在官网和一些blog上看到相关的介绍，但一直没有深入，也没有自己去测试过。今天花了一下午的时间彻底学习了一下calc()。于是就有了这篇blog，希望对大家有所帮助。</p>
<p>　　</p>
<p>平时在制作页面的时候，总会碰到有的元素是100%的宽度。众所周知，如果元素宽度为100%时，其自身不带其他盒模型属性设置还好，要是有别的，那将导致盒子撑破。比如说，有一个边框，或者说有margin和padding，这些都会让你的盒子撑破。我们换句话来说，如果你的元素宽度是100%时，只要你在元素中添加了border,padding,margin任何一值，都将会把元素盒子撑破（标准模式下，除IE怪异模式）。这样一来就会相当的麻烦，平时我们碰到这样的现象时，也是相当的谨慎，有时甚至无法解决，只能通过改变结构来实现。就算你通过繁琐的方法实现了，但有于浏览器的兼容性而导致最终效果不一致。虽然前面介绍的CSS3属性中的box-sizing在一定程度上解决这样的问题，其实今天的calc()函数功能实现上面的效果来得更简单。</p>
<h4>什么是calc()?</h4>
<p>学习calc()之前，我们有必要先知道calc()是什么？只有知道了他是个什么东东？在实际运用中更好的使用他。</p>
<p>calc()从字面我们可以把他理解为一个函数function。其实calc是英文单词calculate(计算)的缩写，是css3的一个新增的功能，用来指定元素的长度。比如说，你可以使用calc()给元素的border、margin、pading、font-size和width等属性设置动态值。为何说是动态值呢?因为我们使用的表达式来得到的值。不过calc()最大的好处就是用在流体布局上，可以通过calc()计算得到元素的宽度。</p>
<h4>calc()能做什么？</h4>
<p>calc()能让你给元素的做计算，你可以给一个div元素，使用百分比、em、px和rem单位值计算出其宽度或者高度，比如说&ldquo;width:calc(50% + 2em)&rdquo;，这样一来你就不用考虑元素DIV的宽度值到底是多少，而把这个烦人的任务交由浏览器去计算。</p>
<h4>calc()语法</h4>
<p>calc()语法非常简单，就像我们小时候学加 （+）、减（-）、乘（*）、除（/）一样，使用数学表达式来表示：</p>
<pre class="prettyprint linenums">.elm {<br />
  width: calc(expression);<br />
}
</pre>
<p>其中"expression"是一个表达式，用来计算长度的表达式。</p>
<h4>calc()的运算规则</h4>
<p>calc()使用通用的数学运算规则，但是也提供更智能的功能：</p>
<ol><li>使用&ldquo;+&rdquo;、&ldquo;-&rdquo;、&ldquo;*&rdquo; 和 &ldquo;/&rdquo;四则运算；</li>
<li>可以使用百分比、px、em、rem等单位；</li>
<li>可以混合使用各种单位进行计算；</li>
<li>表达式中有&ldquo;+&rdquo;和&ldquo;-&rdquo;时，其前后必须要有空格，如"widht: calc(12%+5em)"这种没有空格的写法是错误的；</li>
<li>表达式中有&ldquo;*&rdquo;和&ldquo;/&rdquo;时，其前后可以没有空格，但建议留有空格。</li></ol>
<h4>浏览器的兼容性</h4>
<p>浏览器对calc()的兼容性还算不错，在IE9+、FF4.0+、Chrome19+、Safari6+都得到较好支持，同样需要在其前面加上各浏览器厂商的识别符，不过可惜的是，移动端的浏览器还没仅有&ldquo;firefox for android 14.0&rdquo;支持，其他的全军覆没。</p>
<p>大家在实际使用时，同样需要添加浏览器的前缀</p>
<pre class="prettyprint linenums"> .elm {<br />
	/*Firefox*/<br />
	-moz-calc(expression);<br />
	/*chrome safari*/<br />
	-webkit-calc(expression);<br />
	/*Standard */<br />
	calc();<br />
 }
</pre>
<p>通过上面的了解，大家对calc()不在那么陌生，但对于实际的运用可能还是不太了解，那么大家就接下来跟我一起动手，通过实例来了解他吧。首先我们来看一个最常用的实例：</p>
<pre class="prettyprint linenums">&lt;div class="demo"&gt;<br />
	 &lt;div class="box"&gt;&lt;/div&gt;<br />
&lt;/div&gt;
</pre>
<p>上面的结构很简单，就是一个div.demo的元素中包含了一个div.box的元素，接下来我们一步一步来看其中的变化。</p>
<p><strong>第一步：添加普通样式：</strong></p>
<pre class="prettyprint linenums">.demo {<br />
	width: 300px;<br />
	background: #60f;<br />
}<br />
.box {<br />
  width: 100%;<br />
	background: #f60;<br />
	height: 50px;<br />
}
</pre>
<p>此时的效果很简单，就是div.box完全遮盖了div.demo，如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="http://cdn2.w3cplus.com/cdn/farfuture/Ouz4EUG3ANh-URwribCP9qKQUuyOzG4HW09FxzXmsY0/mtime:1344246305/sites/default/files/201202/css3-calc-step1.jpg" /></p>
<p><strong>第二步，在div.box上添加border和padding</strong></p>
<p>这一步很棘手的事情来了，在div.box上添加10px的内距padding，同时添加5px的border：</p>
<pre class="prettyprint linenums">.demo {<br />
	width: 300px;<br />
	background: #60f;<br />
}<br />
.box {<br />
  width: 100%;<br />
  background: #f60;<br />
  height: 50px;<br />
<strong>  padding: 10px;<br />
  border: 5px solid green;</strong><br />
}
</pre>
<p>为了更好的说明问题，我在div.demo上添加了一个padding：3px 0;</p>
<pre class="prettyprint linenums">.demo {<br />
	width: 300px;<br />
	background: #60f;<br />
<strong>padding: 3px 0;</strong><br />
}<br />
.box {<br />
  width: 100%;<br />
  background: #f60;<br />
  height: 50px;<br />
  padding: 10px;<br />
  border: 5px solid green;<br />
}
</pre>
<p>这个时候大家不知道能否想到问题会发生在哪？其实很简单，这个时候div.box的宽度大于了其容器div.demo的总宽度，从而撑破容器伸出来了，如图所示：</p>
<p><img referrerpolicy="no-referrer"src="http://cdn2.w3cplus.com/cdn/farfuture/wRsB0srprkG3EkEe4z3uuUDfMdf036hXsiAalIRU6VU/mtime:1344246305/sites/default/files/201202/css3-calc-step2.jpg" /></p>
<p><strong>第三步，calc()的运用</strong></p>
<p>为了解决撑破容器的问题，以前我们只能去计算div.box的宽度，用容器宽度减去padding和border的值，但有时候，我们苦于不知道元素的总宽度，比如说是自适应的布局，只知道一个百分值，但其他的值又是px之类的值，这就是难点，死卡住了。随着CSS3的出现，其中利用box-sizing来改变元素的盒模型类型实使实现效果，但今天我们学习的calc()方法更是方便。</p>
<p>知道总宽度是100%，在这个基础上减去boder的宽度（5px * 2 = 10px）,再减去padding的宽度（10px * 2 = 20px），即"100% - (10px + 5px) * 2 = 30px" ，最终得到的值就是合理的没有被内部div.box撑破的width值：</p>
<pre class="prettyprint linenums">.demo {<br />
	width: 300px;<br />
	background: #60f;<br />
	padding: 3px 0;<br />
}<br />
.box {<br />
	background: #f60;<br />
	height: 50px;<br />
	padding: 10px;<br />
	border: 5px solid green;<br />
<strong>width: 90%;/*写给不支持calc()的浏览器*/<br />
	width:-moz-calc(100% - (10px + 5px) * 2);<br />
	width:-webkit-calc(100% - (10px + 5px) * 2);<br />
	width: calc(100% - (10px + 5px) * 2);</strong><br />
}
</pre>
<p>这样一来，通过calc()计算后，div.box不在会超出其容器div.demo的宽度，如图所示：</p>
<p><img referrerpolicy="no-referrer"src="http://cdn.w3cplus.com/cdn/farfuture/-lnY-9fIBBM6NmRUGzPhlFTDyTmEzKxm7cI8esjXOYU/mtime:1344246306/sites/default/files/201202/css3-calc-step3.jpg" /></p>
<p>上面的demo是一个非常简单而常见的布局效果，在这个布局中，我采用了自适应布局。</p>
<p>转自https://www.cnblogs.com/avon/p/5908393.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pz7k8x.html">明显调用的表达式前的括号必须具有&lpar;指针&rpar;函数类型 编译器错误 C2064</a>
		</li>
						<li><a href="https://www.batexi.com/a/495xkr68.html">Beta阶段第六次Scrum Meeting</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7l0318.html">mac的webdriver自动化</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdv2nxq.html">HDU 5690：2016&amp;quot&semi;百度之星&amp;quot&semi; - 初赛 All X</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq135z58.html">Leetcode 21 Merge Two Sorted Lists 链表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmerk49.html">解决两台虚拟机互ping可通，但connect失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1kp239.html">ORA-01078、ORA-01565、ORA-17503、ORA-29701</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnx42v8.html">sqlplus中常用设置参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpjd6xq.html">string，stringbuilder和stringbuffer的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1r4jmq.html">电器ERP行业案例&mdash;&mdash;环力科技</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd37x49.html">gitlab 添加SSH Key</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkvej8.html">JavaScript之事件及动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp25oxq.html">Git  简单粗暴使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvkywy8.html">maven配置及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vz20q.html">linux  网卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zywpld9.html">实验吧&mdash;安全杂项&mdash;&mdash;WP之 女神</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26ozj9.html">1、str&period;join&lpar;&rpar;  2、fromkeys&lpar;&rpar;   3、深浅拷贝   4、set&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx22gmj8.html">Java并发笔记-未完待续待详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnngrv2q.html">关于iframe的父页面调取子页面里的事件（父往子里传）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90drlym8.html">c&num; 获取文件夹大小</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7endrk9.html">pygame经典sprite精灵类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emo31m9.html">WebGL编程指南案例解析之多数据存储于一个缓冲区以及着色器通信</a>
			</li>
						<li><a href="https://www.batexi.com/a/902e4zoq.html">SecureCRT来上传和下载文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpdrel9.html">Linux运维学习笔记-TCP三次握手和四次挥手</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvr07xq.html">adb安装启动Touch校正软件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvrljgq.html">JS校验   if &lpar;&excl; temp&lowbar;var&rpar; &lbrace;&rcub;  &sol;&sol;拦截 &amp;&num;39&semi;&amp;&num;39&semi;和 undefined</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjovgvq.html">Json&period;NET Updates&colon; Merge&comma; Dependency Injection&comma; F&num; and JSONPath Support</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkjnkd8.html">mockito框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkjz5n8.html">php 图片剪切</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vj3v5q.html">Selenium2&plus;python自动化40-cookie相关操作</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
